/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the InboxSettingsMessengerLimitsInnerMessageTypesInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &InboxSettingsMessengerLimitsInnerMessageTypesInner{}

// InboxSettingsMessengerLimitsInnerMessageTypesInner struct for InboxSettingsMessengerLimitsInnerMessageTypesInner
type InboxSettingsMessengerLimitsInnerMessageTypesInner struct {
	Type *MessageType `json:"type,omitempty"`
	Size *int32 `json:"size,omitempty"`
	MimeTypes []string `json:"mime_types,omitempty"`
}

// NewInboxSettingsMessengerLimitsInnerMessageTypesInner instantiates a new InboxSettingsMessengerLimitsInnerMessageTypesInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewInboxSettingsMessengerLimitsInnerMessageTypesInner() *InboxSettingsMessengerLimitsInnerMessageTypesInner {
	this := InboxSettingsMessengerLimitsInnerMessageTypesInner{}
	return &this
}

// NewInboxSettingsMessengerLimitsInnerMessageTypesInnerWithDefaults instantiates a new InboxSettingsMessengerLimitsInnerMessageTypesInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewInboxSettingsMessengerLimitsInnerMessageTypesInnerWithDefaults() *InboxSettingsMessengerLimitsInnerMessageTypesInner {
	this := InboxSettingsMessengerLimitsInnerMessageTypesInner{}
	return &this
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *InboxSettingsMessengerLimitsInnerMessageTypesInner) GetType() MessageType {
	if o == nil || IsNil(o.Type) {
		var ret MessageType
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InboxSettingsMessengerLimitsInnerMessageTypesInner) GetTypeOk() (*MessageType, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *InboxSettingsMessengerLimitsInnerMessageTypesInner) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given MessageType and assigns it to the Type field.
func (o *InboxSettingsMessengerLimitsInnerMessageTypesInner) SetType(v MessageType) {
	o.Type = &v
}

// GetSize returns the Size field value if set, zero value otherwise.
func (o *InboxSettingsMessengerLimitsInnerMessageTypesInner) GetSize() int32 {
	if o == nil || IsNil(o.Size) {
		var ret int32
		return ret
	}
	return *o.Size
}

// GetSizeOk returns a tuple with the Size field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InboxSettingsMessengerLimitsInnerMessageTypesInner) GetSizeOk() (*int32, bool) {
	if o == nil || IsNil(o.Size) {
		return nil, false
	}
	return o.Size, true
}

// HasSize returns a boolean if a field has been set.
func (o *InboxSettingsMessengerLimitsInnerMessageTypesInner) HasSize() bool {
	if o != nil && !IsNil(o.Size) {
		return true
	}

	return false
}

// SetSize gets a reference to the given int32 and assigns it to the Size field.
func (o *InboxSettingsMessengerLimitsInnerMessageTypesInner) SetSize(v int32) {
	o.Size = &v
}

// GetMimeTypes returns the MimeTypes field value if set, zero value otherwise.
func (o *InboxSettingsMessengerLimitsInnerMessageTypesInner) GetMimeTypes() []string {
	if o == nil || IsNil(o.MimeTypes) {
		var ret []string
		return ret
	}
	return o.MimeTypes
}

// GetMimeTypesOk returns a tuple with the MimeTypes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InboxSettingsMessengerLimitsInnerMessageTypesInner) GetMimeTypesOk() ([]string, bool) {
	if o == nil || IsNil(o.MimeTypes) {
		return nil, false
	}
	return o.MimeTypes, true
}

// HasMimeTypes returns a boolean if a field has been set.
func (o *InboxSettingsMessengerLimitsInnerMessageTypesInner) HasMimeTypes() bool {
	if o != nil && !IsNil(o.MimeTypes) {
		return true
	}

	return false
}

// SetMimeTypes gets a reference to the given []string and assigns it to the MimeTypes field.
func (o *InboxSettingsMessengerLimitsInnerMessageTypesInner) SetMimeTypes(v []string) {
	o.MimeTypes = v
}

func (o InboxSettingsMessengerLimitsInnerMessageTypesInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o InboxSettingsMessengerLimitsInnerMessageTypesInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.Size) {
		toSerialize["size"] = o.Size
	}
	if !IsNil(o.MimeTypes) {
		toSerialize["mime_types"] = o.MimeTypes
	}
	return toSerialize, nil
}

type NullableInboxSettingsMessengerLimitsInnerMessageTypesInner struct {
	value *InboxSettingsMessengerLimitsInnerMessageTypesInner
	isSet bool
}

func (v NullableInboxSettingsMessengerLimitsInnerMessageTypesInner) Get() *InboxSettingsMessengerLimitsInnerMessageTypesInner {
	return v.value
}

func (v *NullableInboxSettingsMessengerLimitsInnerMessageTypesInner) Set(val *InboxSettingsMessengerLimitsInnerMessageTypesInner) {
	v.value = val
	v.isSet = true
}

func (v NullableInboxSettingsMessengerLimitsInnerMessageTypesInner) IsSet() bool {
	return v.isSet
}

func (v *NullableInboxSettingsMessengerLimitsInnerMessageTypesInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableInboxSettingsMessengerLimitsInnerMessageTypesInner(val *InboxSettingsMessengerLimitsInnerMessageTypesInner) *NullableInboxSettingsMessengerLimitsInnerMessageTypesInner {
	return &NullableInboxSettingsMessengerLimitsInnerMessageTypesInner{value: val, isSet: true}
}

func (v NullableInboxSettingsMessengerLimitsInnerMessageTypesInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableInboxSettingsMessengerLimitsInnerMessageTypesInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


